package at.jku.iic.microfluidics.droplet.basic.architecture.physical.defective;

import java.util.List;

import at.jku.iic.microfluidics.droplet.basic.architecture.EndPoint;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.LaplacePressureParameter;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.PhysicalEdge;

public class DefectiveLaplacePressureParameter extends LaplacePressureParameter {
	
	private double defectGapWidth;
    private double defectDropletRadius;
	
    public DefectiveLaplacePressureParameter(EndPoint<PhysicalEdge> measuredPoint, EndPoint<PhysicalEdge> referencePoint, double gapWidth,
            double dropletRadius, List<PhysicalEdge> emptyEdges, double defectGapWidth, double defectDropletRadius) {
        super(measuredPoint, referencePoint, gapWidth, dropletRadius, emptyEdges);
        this.defectGapWidth = defectGapWidth;
        this.defectDropletRadius = defectDropletRadius;
    }
    
    @Override
    protected double getDefectGapWidth() {
    	return defectGapWidth;
    }
    @Override
    protected double getDefectDropletRadius() {
    	return defectDropletRadius;
    }
    
    public void setDefectGapWidth(double defectGapWidth) {
    	this.defectGapWidth = defectGapWidth;
    }
    public void setDefectDropletRadius(double defectDropletRadius) {
    	this.defectDropletRadius = defectDropletRadius;
    }

    public void setDefects(double defectGapWidth, double defectDropletRadius) {
    	this.defectGapWidth = defectGapWidth;
    	this.defectDropletRadius = defectDropletRadius;
    }

	public void resetDefects() {
		this.defectGapWidth = 1.0;
    	this.defectDropletRadius = 1.0;
	}

}
