package at.jku.iic.microfluidics.droplet.basic.architecture.physical.defective;

import at.jku.iic.microfluidics.droplet.basic.architecture.EndPoint;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.PhysicalEdge;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.PressurePump;

public class DefectivePressurePump extends PressurePump {

    private final double initialInputPressure;
    
	public DefectivePressurePump(EndPoint<PhysicalEdge> pressureSrc, EndPoint<PhysicalEdge> pressureDst, String name,
			double initialInputPressure, double defect) {
		super(pressureSrc, pressureDst, name, initialInputPressure);
		this.initialInputPressure = initialInputPressure;
		setDefect(defect);
	}
	
	public void setDefect(double defect) {
		inputPressure = initialInputPressure * defect;
	}

}
