package at.jku.iic.microfluidics.droplet.basic.architecture.physical.defective;

import at.jku.iic.microfluidics.droplet.basic.architecture.EndPoint;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.PhysicalEdge;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.VolumetricFlowRatePump;

public class DefectiveVolumetricFlowRatePump extends VolumetricFlowRatePump {
	
	private final double initialInputFlowRate;

	public DefectiveVolumetricFlowRatePump(EndPoint<PhysicalEdge> pressureSrc, EndPoint<PhysicalEdge> pressureDst,
			String name, double initialInputFlowRate, double defect) {
		super(pressureSrc, pressureDst, name, initialInputFlowRate);
		this.initialInputFlowRate = initialInputFlowRate;
		setDefect(defect);
	}
	
	public void setDefect(double defect) {
		inputFlowRate = initialInputFlowRate * defect;
	}

}
