package at.jku.iic.microfluidics.droplet.improvedrobustness.parameter;

import java.util.HashMap;
import java.util.Map;

public class ParameterMap extends HashMap<String, Double> {
    private static final long serialVersionUID = 1L;

    public ParameterMap() {
    }

    public ParameterMap(int initialCapacity) {
        super(initialCapacity);
    }

    public ParameterMap(int initialCapacity, float loadFactor) {
        super(initialCapacity, loadFactor);
    }

    public ParameterMap(Map<? extends String, ? extends Double> m) {
        super(m);
    }

    /**
     * Makes a copy of the provided parameter map
     * @param parameterMap
     * @return
     */
    public static ParameterMap makeCopy(ParameterMap parameterMap) {
        ParameterMap newParameterMap = new ParameterMap(parameterMap.size());

        for (Entry<String, Double> entry : parameterMap.entrySet()) {
            newParameterMap.put(entry.getKey(), entry.getValue());
            newParameterMap.put(entry.getKey(), entry.getValue());
        }

        return newParameterMap;
    }
}
