package at.jku.iic.microfluidics.droplet.improvedrobustness.parameter;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.json.JSONArray;
import org.json.JSONObject;

public class Parameters implements Iterable<Parameter> {
    Map<String, Parameter> parameters = new HashMap<>();

    public Parameters() {
    }

    public Parameter add(Parameter parameter) {
        return parameters.put(parameter.name, parameter);
    }

    public Parameter remove(String name) {
        return parameters.remove(name);
    }

    public Parameter get(String name) {
        return parameters.get(name);
    }

    public Collection<Parameter> getParameters() {
        return parameters.values();
    }

    public ParameterMap getParameterMap() {
        ParameterMap parameterMap = new ParameterMap(parameters.size());
        for (Parameter parameter : parameters.values()) {
            parameterMap.put(parameter.name, parameter.value);
        }

        return parameterMap;
    }

    @Override
    public Iterator<Parameter> iterator() {
        return parameters.values().iterator();
    }


    public JSONObject toJSON(){
        JSONObject json = new JSONObject();

        //parameters
        JSONArray jsonParameters = new JSONArray();
        json.put("parameters", jsonParameters);
        for (Parameter parameter : parameters.values()) {
            jsonParameters.put(parameter.toJSON());
        }

        return json;
    }

    public static Parameters fromJSON(JSONObject json) {
        //parameters
        JSONArray jsonParameters = json.getJSONArray("parameters");
        Parameters parameters = new Parameters();
        for (int i = 0; i < jsonParameters.length(); i++) {
            Parameter parameter = Parameter.fromJSON(jsonParameters.getJSONObject(i));
            parameters.add(parameter);
        }

        return parameters;
    }
}
