package at.jku.iic.microfluidics.droplet.improvedrobustness.testarchitectures.syntheticchip;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONObject;

import at.jku.iic.microfluidics.droplet.basic.architecture.Path;
import at.jku.iic.microfluidics.droplet.basic.architecture.physical.PhysicalEdge;

public class DropletPath {
    public String dropletName;
    public List<String> path = new ArrayList<>();

    public DropletPath(String dropletName) {
        this.dropletName = dropletName;
    }

    public JSONObject toJSON() {
        JSONObject json = new JSONObject();
        json.put("dropletName", dropletName);
        json.put("path", path);

        return json;
    }

    public static DropletPath fromJSON(JSONObject json) {
        String dropletName = json.getString("dropletName");
        JSONArray jsonPath = json.getJSONArray("path");

        DropletPath dropletPath = new DropletPath(dropletName);
        for (int i = 0; i < jsonPath.length(); i++) {
            dropletPath.path.add(jsonPath.getString(i));
        }

        return dropletPath;
    }

    public boolean isSameAs(Path<PhysicalEdge>  path) {
        return path.toString().equals(String.join(", ", this.path));
    }
}
