package at.jku.iic.microfluidics.droplet.improvedrobustness.testarchitectures.syntheticchip;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.json.JSONArray;
import org.json.JSONObject;

public class Experiments {
    public String name;
    public Map<String, Experiment> experiments = new HashMap<>();

    public Experiments(String name) {
        this.name = name;
    }

    public Experiment addExperiment(Experiment experiment) {
        return experiments.put(experiment.name, experiment);
    }

    public Experiment getExperiment(String name) {
        return experiments.get(name);
    }

    public Collection<Experiment> getExperiments() {
        return experiments.values();
    }

    public JSONObject toJSON() {
        JSONObject json = new JSONObject();
        json.put("name", name);

        //experiments
        JSONArray jsonExperiments = new JSONArray();
        json.put("experiments", jsonExperiments);
        for (Experiment experiment : experiments.values()) {
            jsonExperiments.put(experiment.toJSON());
        }

        return json;
    }

    public static Experiments fromJSON(JSONObject json) {
        String name = json.getString("name");
        JSONArray jsonExperiments = json.getJSONArray("experiments");

        Experiments experiments = new Experiments(name);

        //experiments
        for (int i = 0; i < jsonExperiments.length(); i++) {
            experiments.addExperiment(Experiment.fromJSON(jsonExperiments.getJSONObject(i)));
        }

        return experiments;
    }
}
