package at.jku.iic.microfluidics.utils;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.nio.file.Path;

public abstract class OutputWriter {

    protected final PrintWriter pw;
    protected final char DELIMITER = ';';

    public OutputWriter(Path file, boolean append) {
        super();

        PrintWriter pw = null;
        try {
            pw = new PrintWriter(new FileOutputStream(file.toFile(), append));
        } catch (FileNotFoundException e) {
            System.err.println("Cannot open file");
            e.printStackTrace();
        } finally {
            this.pw = pw;
        }
    }

    public void close() {

        pw.close();
    }
}
