/*******************************************************************************
 * Copyright (C) 2018 Andreas Grimmer
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 ******************************************************************************/
package at.jku.iic.microfluidics.utils.dumper;

import java.awt.Color;
import java.io.PrintWriter;

/**
 * Dumper interface using an {@link PrintWriter}.<br>
 * 
 * @author Florian Angerer, June 2013
 * @version 1.0
 * @since 1.0
 */
public interface Dumper {

    void generateHeader(PrintWriter w);

    void generateTrailer(PrintWriter w);

    void generateNode(PrintWriter w, String n, String nodeID);

    void generateNode(PrintWriter w, String n, String nodeID, Color nodeColor);

    void generateEdge(PrintWriter w, String src, String description, String dest);

    void generateEdge(PrintWriter w, String src, String description, String dest, Color color, boolean dashed);
}
